--- //depot/projects/trustedbsd/mac/sys/security/mac_mls/mac_mls.c	2003/06/02 12:26:58
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/security/mac_mls/mac_mls.c	2003/06/13 16:12:32
@@ -60,6 +60,10 @@
 #include <sys/socketvar.h>
 #include <sys/pipe.h>
 #include <sys/sysctl.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <fs/devfs/devfs.h>
 
@@ -1117,6 +1121,58 @@
 }
 
 /*
+ * Labeling event operations: System V IPC objects.
+ */
+
+static void
+mac_mls_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr,
+								    struct label *msglabel)
+{
+	struct mac_mls *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msglabel);
+
+	mac_mls_copy_single(source, dest);
+}   
+
+static void 
+mac_mls_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr,
+								    struct label *msqlabel)
+{
+	struct mac_mls *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(msqlabel);
+
+	mac_mls_copy_single(source, dest);
+}
+
+static void
+mac_mls_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr,
+								    struct label *semalabel)
+{
+	struct mac_mls *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(semalabel);
+
+	mac_mls_copy_single(source, dest);
+}
+
+static void
+mac_mls_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								    struct label *shmlabel)
+{
+	struct mac_mls *source, *dest;
+
+	source = SLOT(&cred->cr_label);
+	dest = SLOT(shmlabel);
+
+	mac_mls_copy_single(source, dest);
+}
+
+/*
  * Labeling event operations: network objects.
  */
 static void
@@ -1362,6 +1418,38 @@
 }
 
 /*
+ * Label cleanup/flush operations
+ */
+
+static void
+mac_mls_cleanup_ipc_msgmsg(struct label *msglabel)
+{
+
+	bzero(SLOT(msglabel), sizeof(struct mac_mls));
+}
+
+static void
+mac_mls_cleanup_ipc_msgqueue(struct label *msqlabel)
+{
+
+  bzero(SLOT(msqlabel), sizeof(struct mac_mls));
+}
+
+static void
+mac_mls_cleanup_ipc_sema(struct label *semalabel)
+{
+
+	bzero(SLOT(semalabel), sizeof(struct mac_mls));
+}
+
+static void
+mac_mls_cleanup_ipc_shm(struct label *shmlabel)
+{
+
+	bzero(SLOT(shmlabel), sizeof(struct mac_mls));
+}
+
+/*
  * Access control checks.
  */
 static int
@@ -1517,6 +1605,292 @@
 }
 
 static int
+mac_mls_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_mls_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_mls_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{   
+
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msgptr->label);
+
+	if (!mac_mls_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_mls_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_mls_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_mls_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_mls_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
+mac_mls_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+
+	if (!mac_mls_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_mls_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+								                    int cmd)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&msqkptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_mls_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+						if (!mac_mls_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+static int
+mac_mls_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+								                    int cmd)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+					case SETVAL:
+					case SETALL:
+						if (!mac_mls_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case GETVAL:
+					case GETPID:
+					case GETNCNT:
+					case GETZCNT:
+					case GETALL:
+						if (!mac_mls_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+
+static int
+mac_mls_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if (!mac_mls_dominate_single(subj, obj))
+		return (EACCES);
+
+	return (0);
+}
+
+
+static int
+mac_mls_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr,
+								                        size_t accesstype)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&semakptr->label);
+
+	if( accesstype & SEM_R )
+		if (!mac_mls_dominate_single(subj, obj))
+			return (EACCES);
+
+	if( accesstype & SEM_A )
+		if (!mac_mls_dominate_single(obj, subj))
+			return (EACCES);
+
+	return (0);
+ 
+}
+
+static int
+mac_mls_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int shmflg)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_mls_dominate_single(subj, obj))
+			return (EACCES);
+	if ((shmflg & SHM_RDONLY) == 0) 
+		if (!mac_mls_dominate_single(obj, subj))
+			return (EACCES);
+	
+	return (0);
+}
+
+static int
+mac_mls_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                        int cmd)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+	switch(cmd) {
+					case IPC_RMID:
+					case IPC_SET:
+						if (!mac_mls_dominate_single(obj, subj))
+							return (EACCES);
+						break;
+					case IPC_STAT:
+					case SHM_STAT:
+						if (!mac_mls_dominate_single(subj, obj))
+							return (EACCES);
+						break;
+					default:
+						return (EACCES);
+	}
+	return (0);
+}
+
+#if 0
+
+/* 
+ * TODO: Do we check the integrity of the implicit write access caused
+ * by the bookkeeping tasks associated with the shmdt call, which may 
+ * modify/delete the shmseg meta-data and/or the shared segment itself? 
+ */
+
+static int
+mac_mls_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_mls_dominate_single(obj, subj))
+		return (EACCES);
+	
+	return (0);
+}
+#endif
+
+static int
+mac_mls_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								                         int shmflg)
+{
+	struct mac_mls *subj, *obj;
+
+	if (!mac_mls_enabled)
+		return (0);
+
+	subj = SLOT(&cred->cr_label);
+	obj = SLOT(&shmsegptr->label);
+
+	if (!mac_mls_dominate_single(obj, subj))
+		return (EACCES);
+
+	return (0);
+}
+
+static int
 mac_mls_check_mount_stat(struct ucred *cred, struct mount *mp,
     struct label *mntlabel)
 {
@@ -2438,6 +2812,10 @@
 	.mpo_init_cred_label = mac_mls_init_label,
 	.mpo_init_devfsdirent_label = mac_mls_init_label,
 	.mpo_init_ifnet_label = mac_mls_init_label,
+	.mpo_init_ipc_msgmsg_label = mac_mls_init_label,
+  .mpo_init_ipc_msgqueue_label = mac_mls_init_label,
+  .mpo_init_ipc_sema_label = mac_mls_init_label,
+  .mpo_init_ipc_shm_label = mac_mls_init_label,
 	.mpo_init_ipq_label = mac_mls_init_label_waitcheck,
 	.mpo_init_mbuf_label = mac_mls_init_label_waitcheck,
 	.mpo_init_mount_label = mac_mls_init_label,
@@ -2450,6 +2828,10 @@
 	.mpo_destroy_cred_label = mac_mls_destroy_label,
 	.mpo_destroy_devfsdirent_label = mac_mls_destroy_label,
 	.mpo_destroy_ifnet_label = mac_mls_destroy_label,
+	.mpo_destroy_ipc_msgmsg_label = mac_mls_destroy_label,
+  .mpo_destroy_ipc_msgqueue_label = mac_mls_destroy_label,
+  .mpo_destroy_ipc_sema_label = mac_mls_destroy_label,
+  .mpo_destroy_ipc_shm_label = mac_mls_destroy_label,
 	.mpo_destroy_ipq_label = mac_mls_destroy_label,
 	.mpo_destroy_mbuf_label = mac_mls_destroy_label,
 	.mpo_destroy_mount_label = mac_mls_destroy_label,
@@ -2497,6 +2879,10 @@
 	.mpo_create_fragment = mac_mls_create_fragment,
 	.mpo_create_ifnet = mac_mls_create_ifnet,
 	.mpo_create_ipq = mac_mls_create_ipq,
+	.mpo_create_ipc_msgmsg = mac_mls_create_ipc_msgmsg,
+  .mpo_create_ipc_msgqueue = mac_mls_create_ipc_msgqueue,
+  .mpo_create_ipc_sema = mac_mls_create_ipc_sema,
+  .mpo_create_ipc_shm = mac_mls_create_ipc_shm,
 	.mpo_create_mbuf_from_mbuf = mac_mls_create_mbuf_from_mbuf,
 	.mpo_create_mbuf_linklayer = mac_mls_create_mbuf_linklayer,
 	.mpo_create_mbuf_from_bpfdesc = mac_mls_create_mbuf_from_bpfdesc,
@@ -2510,11 +2896,28 @@
 	.mpo_create_proc0 = mac_mls_create_proc0,
 	.mpo_create_proc1 = mac_mls_create_proc1,
 	.mpo_relabel_cred = mac_mls_relabel_cred,
+	.mpo_cleanup_ipc_msgmsg = mac_mls_cleanup_ipc_msgmsg,
+  .mpo_cleanup_ipc_msgqueue = mac_mls_cleanup_ipc_msgqueue,
+  .mpo_cleanup_ipc_sema = mac_mls_cleanup_ipc_sema,
+  .mpo_cleanup_ipc_shm = mac_mls_cleanup_ipc_shm,
 	.mpo_check_bpfdesc_receive = mac_mls_check_bpfdesc_receive,
 	.mpo_check_cred_relabel = mac_mls_check_cred_relabel,
 	.mpo_check_cred_visible = mac_mls_check_cred_visible,
 	.mpo_check_ifnet_relabel = mac_mls_check_ifnet_relabel,
 	.mpo_check_ifnet_transmit = mac_mls_check_ifnet_transmit,
+  .mpo_check_ipc_msgrcv = mac_mls_check_ipc_msgrcv,
+	.mpo_check_ipc_msgrmid = mac_mls_check_ipc_msgrmid,
+  .mpo_check_ipc_msqget = mac_mls_check_ipc_msqget,
+  .mpo_check_ipc_msqsnd = mac_mls_check_ipc_msqsnd,
+  .mpo_check_ipc_msqrcv = mac_mls_check_ipc_msqrcv,
+  .mpo_check_ipc_msqctl = mac_mls_check_ipc_msqctl,
+  .mpo_check_ipc_semctl = mac_mls_check_ipc_semctl,
+  .mpo_check_ipc_semget = mac_mls_check_ipc_semget,
+  .mpo_check_ipc_semop = mac_mls_check_ipc_semop,
+  .mpo_check_ipc_shmat = mac_mls_check_ipc_shmat,
+  .mpo_check_ipc_shmctl = mac_mls_check_ipc_shmctl,
+/* .mpo_check_ipc_shmdt = mac_mls_check_ipc_shmdt, */
+  .mpo_check_ipc_shmget = mac_mls_check_ipc_shmget,
 	.mpo_check_mount_stat = mac_mls_check_mount_stat,
 	.mpo_check_pipe_ioctl = mac_mls_check_pipe_ioctl,
 	.mpo_check_pipe_poll = mac_mls_check_pipe_poll,
--- //depot/projects/trustedbsd/mac/sys/security/mac_none/mac_none.c	2003/06/02 12:26:58
+++ //depot/user/hdandeka/rishi_SystemVIPC/sys/security/mac_none/mac_none.c	2003/06/13 16:12:32
@@ -57,6 +57,10 @@
 #include <sys/socketvar.h>
 #include <sys/pipe.h>
 #include <sys/sysctl.h>
+#include <sys/msg.h>
+#include <sys/msg_msg.h>
+#include <sys/sem.h>
+#include <sys/shm.h>
 
 #include <fs/devfs/devfs.h>
 
@@ -329,6 +333,34 @@
 
 }
 
+static void 
+mac_none_create_ipc_msgmsg(struct ucred *cred, struct msg *msgptr, 
+		struct label *msglabel)
+{
+
+}
+
+static void 
+mac_none_create_ipc_msgqueue(struct ucred *cred, struct msqid_kernel *msqkptr, 
+		struct label *msqlabel)
+{
+
+}
+
+static void 
+mac_none_create_ipc_sema(struct ucred *cred, struct semid_kernel *semakptr,
+		struct label *semalabel)
+{
+
+}
+
+static void 
+mac_none_create_ipc_shm(struct ucred *cred, struct shmid_kernel *shmsegptr, 
+		struct label *shmalabel)
+{
+
+}
+
 static void
 mac_none_create_ipq(struct mbuf *fragment, struct label *fragmentlabel,
     struct ipq *ipq, struct label *ipqlabel)
@@ -466,6 +498,34 @@
 }
 
 /*
+ * Label cleanup/flush operations
+ */
+static void 
+mac_none_cleanup_ipc_msgmsg(struct label *msglabel)
+{
+
+}
+
+static void 
+mac_none_cleanup_ipc_msgqueue(struct label *msqlabel)
+{
+
+}
+
+static void 
+mac_none_cleanup_ipc_sema(struct label *semalabel)
+{
+
+}
+
+static void 
+mac_none_cleanup_ipc_shm(struct label *shmlabel)
+{
+
+}
+
+
+/*
  * Access control checks.
  */
 static int
@@ -507,6 +567,123 @@
 }
 
 static int
+mac_none_check_ipc_msgmsq(struct ucred *cred, struct msg *msgptr, 
+								        struct msqid_kernel *msqkptr)
+{
+
+				  return (0);
+}
+
+static int
+mac_none_check_ipc_msgrcv(struct ucred *cred, struct msg *msgptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_msgrmid(struct ucred *cred, struct msg *msgptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_msqget(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_msqsnd(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_msqrcv(struct ucred *cred, struct msqid_kernel *msqkptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_msqctl(struct ucred *cred, struct msqid_kernel *msqkptr,
+								    int cmd)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_semctl(struct ucred *cred, struct semid_kernel *semakptr,
+								    int cmd)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_semget(struct ucred *cred, struct semid_kernel *semakptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_semop(struct ucred *cred, struct semid_kernel *semakptr,
+								        size_t accesstype)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_shmat(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								        int shmflg)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_shmctl(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								        int cmd)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_shmdt(struct ucred *cred, struct shmid_kernel *shmsegptr)
+{
+
+				          return (0);
+}
+
+
+static int
+mac_none_check_ipc_shmget(struct ucred *cred, struct shmid_kernel *shmsegptr,
+								         int shmflg)
+{
+
+				          return (0);
+}
+
+static int
 mac_none_check_kenv_dump(struct ucred *cred)
 {
 
@@ -988,6 +1165,10 @@
 	.mpo_init_cred_label = mac_none_init_label,
 	.mpo_init_devfsdirent_label = mac_none_init_label,
 	.mpo_init_ifnet_label = mac_none_init_label,
+	.mpo_init_ipc_msgmsg_label = mac_none_init_label,
+	.mpo_init_ipc_msgqueue_label = mac_none_init_label,
+  .mpo_init_ipc_sema_label = mac_none_init_label,
+  .mpo_init_ipc_shm_label = mac_none_init_label,
 	.mpo_init_ipq_label = mac_none_init_label_waitcheck,
 	.mpo_init_mbuf_label = mac_none_init_label_waitcheck,
 	.mpo_init_mount_label = mac_none_init_label,
@@ -1000,6 +1181,10 @@
 	.mpo_destroy_cred_label = mac_none_destroy_label,
 	.mpo_destroy_devfsdirent_label = mac_none_destroy_label,
 	.mpo_destroy_ifnet_label = mac_none_destroy_label,
+	.mpo_destroy_ipc_msgmsg_label = mac_none_destroy_label,
+	.mpo_destroy_ipc_msgqueue_label = mac_none_destroy_label,
+  .mpo_destroy_ipc_sema_label = mac_none_destroy_label,
+  .mpo_destroy_ipc_shm_label = mac_none_destroy_label,
 	.mpo_destroy_ipq_label = mac_none_destroy_label,
 	.mpo_destroy_mbuf_label = mac_none_destroy_label,
 	.mpo_destroy_mount_label = mac_none_destroy_label,
@@ -1025,6 +1210,10 @@
 	.mpo_create_devfs_device = mac_none_create_devfs_device,
 	.mpo_create_devfs_directory = mac_none_create_devfs_directory,
 	.mpo_create_devfs_symlink = mac_none_create_devfs_symlink,
+	.mpo_create_ipc_msgmsg = mac_none_create_ipc_msgmsg,
+	.mpo_create_ipc_msgqueue = mac_none_create_ipc_msgqueue,
+	.mpo_create_ipc_sema = mac_none_create_ipc_sema,
+	.mpo_create_ipc_shm = mac_none_create_ipc_shm,
 	.mpo_create_vnode_extattr = mac_none_create_vnode_extattr,
 	.mpo_create_mount = mac_none_create_mount,
 	.mpo_create_root_mount = mac_none_create_root_mount,
@@ -1063,11 +1252,29 @@
 	.mpo_create_proc1 = mac_none_create_proc1,
 	.mpo_relabel_cred = mac_none_relabel_cred,
 	.mpo_thread_userret = mac_none_thread_userret,
+	.mpo_cleanup_ipc_msgmsg = mac_none_cleanup_ipc_msgmsg,
+	.mpo_cleanup_ipc_msgqueue = mac_none_cleanup_ipc_msgqueue,
+	.mpo_cleanup_ipc_sema = mac_none_cleanup_ipc_sema,
+	.mpo_cleanup_ipc_shm = mac_none_cleanup_ipc_shm,
 	.mpo_check_bpfdesc_receive = mac_none_check_bpfdesc_receive,
 	.mpo_check_cred_relabel = mac_none_check_cred_relabel,
 	.mpo_check_cred_visible = mac_none_check_cred_visible,
 	.mpo_check_ifnet_relabel = mac_none_check_ifnet_relabel,
 	.mpo_check_ifnet_transmit = mac_none_check_ifnet_transmit,
+	.mpo_check_ipc_msgmsq = mac_none_check_ipc_msgmsq,
+	.mpo_check_ipc_msgrcv = mac_none_check_ipc_msgrcv,
+	.mpo_check_ipc_msgrmid = mac_none_check_ipc_msgrmid,
+	.mpo_check_ipc_msqget = mac_none_check_ipc_msqget,
+	.mpo_check_ipc_msqsnd = mac_none_check_ipc_msqsnd,
+	.mpo_check_ipc_msqrcv = mac_none_check_ipc_msqrcv,
+	.mpo_check_ipc_msqctl = mac_none_check_ipc_msqctl,
+	.mpo_check_ipc_semctl = mac_none_check_ipc_semctl,
+	.mpo_check_ipc_semget = mac_none_check_ipc_semget,
+	.mpo_check_ipc_semop = mac_none_check_ipc_semop,
+	.mpo_check_ipc_shmat = mac_none_check_ipc_shmat,
+	.mpo_check_ipc_shmctl = mac_none_check_ipc_shmctl,
+	.mpo_check_ipc_shmdt = mac_none_check_ipc_shmdt,
+	.mpo_check_ipc_shmget = mac_none_check_ipc_shmget,
 	.mpo_check_kenv_dump = mac_none_check_kenv_dump,
 	.mpo_check_kenv_get = mac_none_check_kenv_get,
 	.mpo_check_kenv_set = mac_none_check_kenv_set,
